sub main()
     print "Starting Family Photos"

     m.imageSizeX = 1280
     m.imageSizeY = 720
     m.index = 0

     port = CreateObject("roMessagePort")
     m.screen = CreateObject("roImageCanvas")
     m.screen.SetMessagePort(port)
     ' m.screen.SetRequireAllImagesToDraw(true)

     m.arrayImages = [ 
          { url:"pkg:/images/Slide01.jpg",
            TargetRect:{x:0,y:0,w:1280,h:720 }
          },
          { url:"pkg:/images/Slide02.jpg", 
            TargetRect:{x:0,y:0,w:1280,h:720 }
          },
          { url:"pkg:/images/Slide03.jpg",
            TargetRect:{x:0,y:0,w:1280,h:720 }
          }
     ]
     m.slideCount = m.arrayImages.Count()

     m.screen.SetLayer(0, {Color:"#FF000040", CompositionMode:"Source"})
     m.screen.SetLayer(2, m.arrayImages[m.index])
     m.screen.Show()

     change_slide()

     while(true)

         msg = wait(0, port) 
         If type(msg) = "roImageCanvasEvent" and msg.isRemoteKeyPressed() Then
               button = msg.GetIndex()
               print "button is "; button

               if ((button = 5) Or (button = 6)) and m.index < m.slideCount - 1
                    print "Show Next Slide"
                    m.index = m.index + 1
                    change_slide()
               else if (button = 4) And (m.index > 0)
                    print "Show Previous Slide"
                    m.index = m.index - 1
                    change_slide()
               else if (button = 10)  ' Info button
                    display_dialog()
               end if
          end if


     end while

end sub


function display_dialog()
     dialog = CreateObject("roPinEntryDialog")
     dialog.SetMessagePort(CreateObject("roMessagePort"))
     dialog.EnableOverlay(true)
     dialog.EnableBackButton(true)
     dialog.SetNumPinEntryFields(4)
     dialog.SetTitle("Enter your Roku PIN to begin your free trial.")
     dialog.AddButton(1, "Continue")
     dialog.AddButton(99, "Back")
     dialog.Show()
     while True
          msg = wait(0, dialog.GetMessagePort())
          if msg <> invalid
               print "msg is "; msg
               if msg.isScreenClosed()
                    print "msg is isScreenClosed"; msg
                    exit while
               else if msg.isButtonPressed()
                    print "the index of the button pressed is"; msg.GetIndex()
                    if msg.GetIndex() = 1
                         print "The user entereded PIN "; dialog.Pin()
                    else if msg.GetIndex() = 99
                         print "The user cancelled."
                    endif
                    exit while
               end if
          end if
     end while
     print "Just before dialog.Close"
     dialog.Close()
end function


function change_slide()

''     if m.index < 0
''          m.nextBitmap = CreateObject("roBitmap", "pkg:/images/background.jpg")
''     else if m.index >= m.slideCount
''          m.nextBitmap = CreateObject("roBitmap", "pkg:/images/background.jpg")
''     else
''          m.nextBitmap = CreateObject("roBitmap", m.arrayImages[m.index])
''     end if

     m.screen.ClearLayer(1)
     m.screen.SetLayer(1, m.arrayImages[m.index])
     m.screen.SwapLayers(1,2)

''     m.nextBitmap.SetAlphaEnable(true)
''
''     for i = 0 to 255 step 5
''          hexcolor = &hFFFFFFFF - i
''          hexcolor2  = &hFFFFFF00 + i
''
''          m.screen.DrawScaledObject(0, 0, m.scaleX, m.scaleY, m.currentBitmap, hexcolor) 'fadeout
''          m.screen.DrawScaledObject(0, 0, m.scaleX, m.scaleY, m.nextBitmap, hexcolor2) 'fadein
''
''          m.screen.SwapBuffers()
''     end for

     m.screen.ClearLayer(1)

end function

